.org $4000
#include "ti83plus.inc"
#include "macrodie.inc"
#include "labels.inc"
; change this to your ID
#define DEVELOPER_ID    $01,$23,$45

EXT_APP = 1                         ; This definition is required of all apps

; This is the application header definition area required for all apps.

 .db $80, $0F                       ; Field: Program length
 .db 0, 0, 0, 0                     ; Length = 0 (N/A for unsigned apps)

#ifdef SIGN_APP
 .db $80, $13                       ; Field: Program type
 .db DEVELOPER_ID                   ; Type = Developer ID
#else
 .db $80, $12                       ; Field: Program type
 .db $01,$04                        ; Type = Shareware, TI-83+
#endif

 .db $80, $21                       ; Field: App ID
 .db 1                              ; Id = 1
 .db $80, $31                       ; Field: App Build
 .db 1                              ; Build = 1
 .db $80, $48                       ; Field: App Name
 .db "MACOSLIB"                     ; Name -- must be 8 characters
 .db $80, $81                       ; Field: App Pages
 .db 1                              ; App Pages = 1
 .db $80, $90                       ; No default splash screen
 .db $03, $26, $09, $04, $04, $6f, $1b, $80             ; Field: Date stamp- 5/12/1999
 .db $02, $0d, $40, $a1, $6b, $99, $f6, $59, $bc, $67   ; Dummy encrypted TI date stamp signature
 .db $f5, $85, $9c, $09, $6c, $0f, $b4, $03, $9b, $c9
 .db $03, $32, $2c, $e0, $03, $20, $e3, $2c, $f4, $2d 
 .db $73, $b4, $27, $c4, $a0, $72, $54, $b9, $ea, $7c 
 .db $3b, $aa, $16, $f6, $77, $83, $7a, $ee, $1a, $d4 
 .db $42, $4c, $6b, $8b, $13, $1f, $bb, $93, $8b, $fc 
 .db $19, $1c, $3c, $ec, $4d, $e5, $75
 .db $80, $7f                       ; Field: Program Image length
 .db   0, 0, 0, 0                   ; Length = 0, N/A
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0                      ; Reserved
#ifndef SIGN_APP
 .db 0      ; add another pad byte if using only 2-byte keyfile
#endif

;
;

;  Main app control begins here
StartApp:
activ_task                        .equ _textShadow
xpos                              .equ _textShadow+1;1
ypos                              .equ _textShadow+2;1
activ_task_name                   .equ _textShadow+3 ;3+8=11+1=12 next a 12
size                              .equ _textShadow+12 ;12+2=14 next a 14
last_activ_process                .equ _textShadow+14 ;aponta para uma pasta ou um programa
close_task                        .equ _textShadow+15
temp_DE                           .equ _textShadow+16
data_size                         .equ _textShadow+18 ;2 bytes
temp_data                         .equ _textShadow+20 ;2 bytes
tamanho_a_subtrair_a_proxima_task .equ _textShadow+22;2bytes
valid_data                        .equ _textShadow+24 ;2 bytes 
temp_size                         .equ _textShadow+26 ;2bytes
temp_C                            .equ _textShadow+28 ;1 byte
animar_flag                       .equ _textShadow+29 ;1 byte
animar                            .equ _textShadow+30 ;2 bytes
start_button                      .equ _textShadow+32;1 byte
screen                            .equ _textShadow+33
scroll_x                          .equ _textShadow+34;valores utilizados pelo scroll como sao utilizados por varias
scroll_y                          .equ _textShadow+35;OS-APIS tem de ser constantemente apagadas antes de utilizadas
temp_close_task                   .equ _textShadow+36
tamanho_a_somar                   .equ _textShadow+37 ;2bytes
temp_B                            .equ _textShadow+39
temp_HL                           .equ _textShadow+40;2bytes
buffer                            .equ _textShadow+42;64 bytes proxima a 106
tamanho_a_ler                     .equ _textShadow+107;2 bytes
tamanho_das_variaveis             .equ _textShadow+109 ;2 bytes
temp_A                            .equ _textShadow+111
pasta_process                     .equ _textShadow+112
type_of_task                      .equ _textShadow+113
counter                           .equ _textShadow+114
menu                              .equ _textShadow+115;323 bytes maximo
botao_tasks_flag                  .equ _textShadow+116
page_counter                      .equ _textShadow+117
endereco_de_execucao              .equ _textShadow+118;2 bytes
numero_entrys                     .equ _textShadow+120;1 byte
menu11                            .equ _textShadow+121
menu22                            .equ _textShadow+122
menu33                            .equ _textShadow+123
menu44                            .equ _textShadow+124
menu55                            .equ _textShadow+125
menu66                            .equ _textShadow+126
background_counter                .equ _textShadow+127
;swap_memory                       .equ $9BD0;temp memory
bar_size                          .equ swap_memory;memoria de utilizacao variavel
dealocation                       .equ swap_memory+1;valor de deslocaao
actual_page_counter               .equ swap_memory+2
free_memory                       .equ swap_memory+3;2bytes used by mem routines to return the amount of free ram
ASM_FLAG11                        .equ swap_memory+5
ASM_FLAG22                        .equ swap_memory+6
ASM_FLAG33                        .equ swap_memory+7
last_activ_ram_area               .equ swap_memory+17;this variable controls the ram struct
button_down_flag                  .equ swap_memory+18
button_up_flag                    .equ swap_memory+19
ram_memory_flag                   .equ swap_memory+20
CPU_info                          .equ swap_memory+21;1byte for info on CPU
speed_now                         .equ swap_memory+22;1 byte de reserva para a velocidade
var_flag1                         .equ ASM_FLAG11;used by many aplications including Macrodie so don't expect that your value is preserved
var_flag2                         .equ ASM_FLAG22;used by many aplications including Macrodie so don't expect that your value is preserved
var_flag3                         .equ ASM_FLAG33;used by many aplications including Macrodie so don't expect that your value is preserved 
save_screen_name                  .equ swap_memory+8;8 bytes
task_name_table                   .equ _STATVARS
#define save_registers(m,a)     \ PUSH IY \ PUSH IX \ PUSH HL \ PUSH DE \ PUSH BC \ PUSH AF
#define restore_registers(m,a)  \ POP  AF \ POP  BC \ POP  DE \ POP  HL \ POP  IX \ POP  IY

    ; this is the library functions 
    ; when we use invoke we could start any of this functions
    jp   error_ti_os;tios cannot execute this app
    jp   tell_macrodie_that_this_is_an_library
    jp   execute_background_task;this aplication executes in background only when to
    RET \ RET \ RET ;Mirageos prevent execution
    jp   do_you_want_to_restart;4
    jp   do_you_want_to_shutdown;5
    jp   loade_commander_into_ram;6
    jp   loade_MPC_into_ram;7
    jp   loade_pasta_indef_into_ram;8
    jp   loade_reciclagem_into_ram;9
    jp   loade_run_into_ram
    jp   loade_mouse_driver_into_memory;loade it into memory



;Code start 
do_you_want_to_shutdown:
    LD   HL,_shutdown_msg
    LD   DE,buffer
    LD   BC,_shutdown_msg_end - _shutdown_msg
    LDIR 
    LD   HL,buffer
    xor  a
    invoke( MsgBox_Ok )
    LD   A,B
    RET

do_you_want_to_restart:
    LD   HL,_restart
    LD   DE,buffer
    LD   BC,_restart_end - _restart
    LDIR
    LD   HL,buffer
    xor  a
    invoke( MsgBox_Ok )
    LD   A,B
    RET


_shutdown_msg:
    .db "Do you want to shutdown???",0
_shutdown_msg_end:

_restart:
    .db "Do you want to restart???",0
_restart_end:

loade_commander_into_ram:
    call start_variable_context
    PUSH BC
    LD   BC,commander_end - commander_main
    call check_enought_memory
    POP  BC
    CP   1 \ jp   z,memory_error
    LD   HL,commander_text
    PUSH BC \ PUSH DE
    call swap_it_into_buffer
    POP  DE \ POP  BC
    LD   HL,buffer
    
    xor  a
    invoke( write_first_parte_of_header );write the PID 
    LD   BC,commander_end - commander_main;tamanho do processo a mover
    LD   HL,commander_init
do_hard_stuff:
    call initialize_variable_field
    
    xor  a
    invoke( copiando_e_compilando_task );
    LD     A,(last_activ_process)
    LD     (activ_task),A
    XOR    A
    LD     (screen),A
    LD     A,1
    LD     (botao_tasks_flag),A
    RET;change for it right now

loade_MPC_into_ram:
    ;as this variables work with the multipages architecture we must change the system behaviour
    call start_variable_context
    PUSH BC
    LD   BC,meu_computador_process_end - meu_computador_main_task
    call check_enought_memory
    POP  BC
    CP   1 \ jp   z,memory_error
    LD   HL,meu_computador_text
    PUSH BC \ PUSH DE
    call swap_it_into_buffer
    POP  DE \ POP  BC
    
    LD   HL,buffer
    
    xor  a
    invoke( write_first_parte_of_header )
    LD   BC,meu_computador_process_end - meu_computador_main_task;tamanho do processo a mover menos 2 bytes das variaveis
    LD   HL,meu_computador_process_init + 1
    jr   do_hard_stuff
    
loade_pasta_indef_into_ram:
    call start_variable_context
    PUSH BC
    LD   BC,pasta_indef_end - pasta_indef_main
    call check_enought_memory
    POP  BC
    CP   1 \ jp   z,memory_error
    LD   HL,pasta_indef_text
    PUSH BC \ PUSH DE
    call swap_it_into_buffer
    POP  DE \ POP  BC
    
    LD   HL,buffer
    
    xor  a
    invoke( write_first_parte_of_header )
    LD   BC,pasta_indef_end - pasta_indef_main;tamanho do processo a mover menos 2 bytes das variaveis
    LD   HL,pasta_indef_init
    jr   do_hard_stuff    
    

loade_reciclagem_into_ram:
    call start_variable_context
    PUSH BC
    LD   BC,reciclagem_end - reciclagem_main
    
    call check_enought_memory
    POP  BC
    CP   1 \ jp   z,memory_error
    LD   HL,reciclagem_text
    PUSH BC \ PUSH DE
    call swap_it_into_buffer
    POP  DE \ POP  BC
    
    LD   HL,buffer
    
    xor  a
    invoke( write_first_parte_of_header )
    LD   BC,reciclagem_end - reciclagem_main;tamanho do processo a mover menos 2 bytes das variaveis
    LD   HL,reciclagem_init + 1
    jp   do_hard_stuff    


loade_mouse_driver_into_memory:
    call start_variable_context
    PUSH BC
    LD   BC,memory_area_end - mouse_driver_main
    call check_enought_memory
    POP  BC
    CP   1 \ jp   z,memory_error
    LD   HL,mouse_driver_text
    PUSH BC \ PUSH DE
    call swap_it_into_buffer
    POP  DE \ POP  BC
    
    LD   HL,buffer
    
    xor  a
    invoke( write_first_parte_of_header )
    LD   BC,memory_area_end - mouse_driver_main;tamanho do processo a mover menos 2 bytes das variaveis
    LD   HL,mouse_driver_init + 1
    jp   do_hard_stuff    

loade_run_into_ram:
    call start_variable_context
    PUSH BC
    LD   BC,run_end - run_main
    call check_enought_memory
    POP  BC
    CP   1 \ jp   z,memory_error
    LD   HL,run_text
    PUSH BC \ PUSH DE
    call swap_it_into_buffer
    POP  DE \ POP  BC
    
    LD   HL,buffer
    
    xor  a
    invoke( write_first_parte_of_header )
    LD   BC,run_end - run_main;tamanho do processo a mover menos 2 bytes das variaveis
    LD   HL,run_init + 1
    jp   do_hard_stuff    
    
    
    
check_enought_memory:
    PUSH HL \ PUSH DE
    LD   HL,(tamanho_a_somar);obtenho o tamanho a somar
    LD   DE,$9D95
    ADD  HL,DE;obtenho o endereco do byte a seguir a ultima tarefa
    LD   DE,$C000
    EX   DE,HL
    OR   A
    SBC  HL,DE
    ;agora obtenho o tamanho livre 
    ;bc tem o tamanho que a tarefa a executar ocupa
    PUSH BC
    POP  DE;agora o bc esta em DE
    bcall _CpHLDE
    jr   c,error_of_memory
    POP  DE  \ POP  HL
    xor  a
    RET
error_of_memory
    LD   A,1
    POP  DE
    POP  HL
    RET




start_variable_context:
    XOR   A
    LD    (start_button),A
    LD    A,1
    LD    (pasta_process),A    
continuar_compilacao:    
    LD    A,(last_activ_process) ;erro notado aki mas ja esta corrigido
    LD    C,A
    OR    A \ jr   z,set_to_9d95
    xor   a
    invoke( find_task )
    LD    HL,(size)
    ADD   HL,DE    
    LD    (temp_HL),HL
voltando_ao_meu_commander:
    LD    DE,$9D95
    SCF \ CCF
    SBC   HL,DE
    INC   HL;como o valor nao vai sobrepor uma variavle da task anterior eu tenho de adicionar 1
    LD    (tamanho_a_somar),HL;erro notado aki mas ja esta corrigido    
    RET

set_to_9d95:
    LD    HL,$9D95
    LD    (temp_HL),HL
    XOR   A
    LD    (last_activ_process),A
    LD    (activ_task),A
    jr    voltando_ao_meu_commander


swap_it_into_buffer:
    LD   DE,buffer
    LD   BC,8
    LDIR
    RET


initialize_variable_field:
      DI   ;desactivando interrupts necessario maxima velocidade na compilacao      
      LD   E,(HL)
      INC  HL
      LD   D,(HL);tamanho das variaveis em DE
      INC  HL
      LD   (temp_DE),HL
      LD    (tamanho_a_ler),BC ;2 bytes
      LD    (tamanho_das_variaveis),DE
      LD    HL,(tamanho_a_ler)
      LD    BC,(tamanho_das_variaveis)
      SCF \ CCF
      SBC   HL,BC
      LD    (valid_data),HL
      LD    BC,(tamanho_a_ler)
      LD    HL,(temp_HL);comeco a escrever o resto do header
      LD    A,C
      LD    (HL),A
      INC   HL
      LD    A,B
      LD    (HL),A
      INC   HL
      LD    BC,(tamanho_das_variaveis)
      LD    A,C
      LD    (HL),A
      LD    A,B
      INC   HL
      LD    (HL),A
      INC   HL
      LD    (temp_HL),HL
      PUSH  HL
      PUSH  BC
      LD    HL,$000E
      LD    BC,(tamanho_a_somar)
      ADD   HL,BC
      LD    (tamanho_a_somar),HL;falatava o tamnho do header
      POP   BC
      POP   HL
      IN    A,(6)
      LD    B,A
      LD    DE,(temp_DE)
      EX    DE,HL
      RET
      
memory_error:;this defines an memory error if there is no space available for including the next task
      LD    HL,memory_error_text
      LD    BC,memory_text_end - memory_error_text
      LD    DE,buffer
      LDIR
      LD    HL,buffer
      xor   a
      invoke( MsgBox_Ok)
      XOR   A
      LD    (activ_task),A
      LD    (close_task),A
      LD    (animar_flag),A
      RET 





memory_error_text: .db "There's no ram space for that task??? Please close one in order to start another",0
memory_text_end

;Necessary macrodie aplications code
;
;




execute_background_task:
    RET;libraries do not have back ground processing
    
    
tell_macrodie_that_this_is_an_library:
    LD    A,2
    RET;return to whatever

error_ti_os:
    DI
    bcall _GRBUFCLR
    EI
    LD  HL,error_ti_os1
    LD  DE,buffer
    LD  BC,error_end - error_ti_os1
    LDIR
    LD  HL,buffer
    LD  DE,$0000
    LD  (_penCol),DE
    bcall _VPutS
    bcall _GetKey
    
    bjump _JForceCmdNoChar

 
    
    
error_ram_alloc: .db "Error allocating ram please unload some aplications in order to run this one!!! Please press Enter Key!!!",0   
error_ti_os1: .db "Error Ti operating system cann't execute this aplication",0
error_end:     
      
run_text:             .db "runn    ",0
meu_computador_text:  .db "Meu Comp",0
pasta_indef_text:     .db "sys past",0
reciclagem_text:      .db "reciclag",0      
mouse_driver_text:    .db "MouseDrv",0
            
   
#include "macrodie_FSYS\meu_cpu.asm";MPC
#include "macrodie_FSYS\find.asm";commander for find files
#include "macrodie_FSYS\reciclagem.asm";recicle.bin
#include "macrodie_FSYS\run.asm";comando run
#include "macrodie_FSYS\pasta_indef_1.asm";pasta indefenida para aplicacoes
#include "macrodie_FSYS\mouse_driver.asm";cuidado com este por alterar
      

.end
