#include "ti83plus.inc"
#include "macrodie.inc"
.org $4000

; change this to your ID
#define DEVELOPER_ID    $01,$23,$45

EXT_APP = 1                         ; This definition is required of all apps

; This is the application header definition area required for all apps.

 .db $80, $0F                       ; Field: Program length
 .db 0, 0, 0, 0                     ; Length = 0 (N/A for unsigned apps)

#ifdef SIGN_APP
 .db $80, $13                       ; Field: Program type
 .db DEVELOPER_ID                   ; Type = Developer ID
#else
 .db $80, $12                       ; Field: Program type
 .db $01,$04                        ; Type = Shareware, TI-83+
#endif

 .db $80, $21                       ; Field: App ID
 .db 1                              ; Id = 1
 .db $80, $31                       ; Field: App Build
 .db 1                              ; Build = 1
 .db $80, $48                       ; Field: App Name
 .db "new app "                     ; Name -- must be 8 characters
 .db $80, $81                       ; Field: App Pages
 .db 1                              ; App Pages = 1
 .db $80, $90                       ; No default splash screen
 .db $03, $26, $09, $04, $04, $6f, $1b, $80             ; Field: Date stamp- 5/12/1999
 .db $02, $0d, $40, $a1, $6b, $99, $f6, $59, $bc, $67   ; Dummy encrypted TI date stamp signature
 .db $f5, $85, $9c, $09, $6c, $0f, $b4, $03, $9b, $c9
 .db $03, $32, $2c, $e0, $03, $20, $e3, $2c, $f4, $2d 
 .db $73, $b4, $27, $c4, $a0, $72, $54, $b9, $ea, $7c 
 .db $3b, $aa, $16, $f6, $77, $83, $7a, $ee, $1a, $d4 
 .db $42, $4c, $6b, $8b, $13, $1f, $bb, $93, $8b, $fc 
 .db $19, $1c, $3c, $ec, $4d, $e5, $75
 .db $80, $7f                       ; Field: Program Image length
 .db   0, 0, 0, 0                   ; Length = 0, N/A
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0, 0                   ; Reserved
 .db   0, 0, 0                      ; Reserved
#ifndef SIGN_APP
 .db 0      ; add another pad byte if using only 2-byte keyfile
#endif

swap_mem     .equ _SaveSScreen; as macrodie doesnt use this memory area we could use it as a swap memory






;  Main app control begins here
StartApp:
    jp   error_ti_os;tios cannot execute this app
    jp   tell_macrodie_that_this_is_an_program;not driver and not library not macrodie
    jp   execute_background_task;
STARTAPP: ;main control begins here
    xor  a
    invoke( create_default_pasta );create a window on desktop
    
    ;// it will use the fullScreen    
    LD   HL,aplication_name
    call copy_to_OP1;OP1 active
    LD   HL,100;100B of free mem to reserve and IX can range from -128 to +128 for more we have to calculate the offset
    xor  a
    invoke( allocate_ram_area );allocate some ram for the system
    CP   1 \ jp  z,ram_alloc_error
    
   
   
   
   




fechar_aplicacao:
    LD   HL,aplication_name
    call copy_to_OP1;OP1 active
    xor  a
    invoke( deallocate_ram_area )
    LD   A,(activ_task)
    LD   (close_task),A
fechar_aplica:
    XOR  A
    LD   (activ_task),A
    LD   (screen),A
    LD   (animar_flag),A
    RET;volto ao programa que esta a executar ou seja a pagina do macrodie e ao programa que me executou
minimizar_aplicacao:
    XOR  A
    LD   (close_task),A
    jr   fechar_aplica    






execute_background_task:
;blink cursor and update it to screen
    RET;para ja volta apenas para traz pois ainda nao tem nada defenido    













putsprite_function:
    PUSH  HL
    PUSH  BC
    PUSH  IX
    POP   HL 
    LD    DE,swap_mem
    LD    BC,16;16 bytes a copiar
    LDIR
    POP   BC
    POP   HL
    LD    IX,swap_mem
    xor  a;macrodie page
    invoke( putsprite ); poe me o sprite no ecra
    RET
copy_to_OP1:
    LD   DE,_OP1
    LD   BC,8
    LDIR
    RET


























;error zone
ram_alloc_error:
    LD   HL,error_ram_alloc
    LD   DE,_SaveSScreen;buffer mem can be used for what ever
    LD   BC,error_ti_os1 - error_ram_alloc
    LDIR;copy it to ram
    LD   DE,0
    LD   (_curCol),DE
    LD   HL,error_ram_alloc
    bcall _PutS
Enter_loop:
    LD   A,$FD
    OUT  (1),A
    IN   A,(1)
    CP   $FE;Enter key pressed
    jr   nz,Enter_loop
    jp    fechar_aplicacao;terminar aplicacao
        
    






tell_macrodie_that_this_is_an_program:
    LD    A,1;popular value fit here the value 1 for program 2 for driver 3 for librarie 
    RET;return to whatever




error_ti_os:
    DI
    bcall _GRBUFCLR
    EI
    LD  HL,error_ti_os1
    LD  DE,buffer
    LD  BC,error_end - error_ti_os1
    LDIR
    LD  HL,buffer
    LD  DE,$0000
    LD  (_penCol),DE
    bcall _VPutS
    bcall _GetKey
    
    bjump _JForceCmdNoChar


    
    
error_ram_alloc: .db "Error allocating ram please unload some aplications in order to run this one!!! Please press Enter Key!!!",0   
error_ti_os1: .db "Error Ti operating system cann't execute this aplication",0
error_end:
aplication_name: .db "new app ",0;the app name 8 bytes















.end
.end
