;-------------= Fall Down =-------------
; Author:       Ian Graf (port)
;               (ian_graf@geocities.com)
;               Florent Dhordain (original)
;               (flo.dh@usa.net)
;               Ahmed El-Helw (original)
;               (ahmedre@bellsouth.net)
; Version:      1.5
; Platform:     ION-originally modified for macrodie operating system shell
; Date:         11/3/99 ->
; reconverted: by rayden creator of macrodie operating system shell
;---------------------------------------





;---------------= header =--------------
#include        "ti83plus.inc"
#include        "macrodie.inc"
.org $9D95
     ret
     jr     start_of_program;//this jump desnt do anithing is only a protection sheme
     LD     BC,end_of_vars - start_of_vars
icon:;icon of the prog to disp on the folder
;.db 16, 16
.db %00000000, %00000000
.db %00000000, %00000000
.db %01110010, %01000100
.db %01000101, %01000100
.db %01100111, %01000100
.db %01000101, %01000100
.db %01000101, %01110111
.db %00000000, %00000000
.db %00000000, %00000000
.db %01100011, %00100010
.db %01010100, %10100010
.db %01010100, %10100010
.db %01010100, %10101010
.db %01100011, %00010100
.db %00000000, %00000000
.db %00000000, %00000000

start_of_program:
        LD   A,(background_program_status)
        CP   1 \ jr   z,program_already_added
        LD   A,1
        LD   (background_program_status),A
        LD   HL,background_task
        xor  a
        invoke( ADD_program_to_background )
;//    background task is not needed on this program      
program_already_added:
        bcall _ClrLCDFull               ;
        ld      de,0*256+16              ;
        ld      (_penCol),de             ;
        ld      hl,titlestr             ;
        set     fracDrawLFont, (IY + fontFlags)
        bcall   _VPutS                     ;
        res     fracDrawLFont, (IY + fontFlags)
        ld      bc,0*256+55             ; draw line
        ld      de,94*256+55            ;
        bcall _DARKLINE                 ;
        ld      de,10*256+1             ; write "By AE, FD, and IG"
        ld      (_penCol),de             ;
        ld      hl,authorstr            ;
        
        bcall   _VPutS
        ld      de,17*256+4             ; write "2nd - Start"
        ld      (_penCol),de             ;
        bcall _VPutS                    ;
        ld      de,24*256+4             ; write "2nd - Start"
        ld      (_penCol),de             ;
        bcall _VPutS                    ;
        ld      de,31*256+4             ; write "ALPHA - Speed:"
        ld      (_penCol),de             ;
        bcall _VPutS                    ;
        ld      de,38*256+4             ; write "CLEAR - Exit:"
        ld      (_penCol),de             ;
        bcall _VPutS                    ;
        ld      de,55*256+1             ; write "High: "
        ld      (_penCol),de             ;
        bcall _VPutS                    ;
        ld      hl,(high)               ;
        bcall _SetXXXXOP2               ; write high score
        bcall _OP2ToOP1                 ;
        ld      a,5                     ;
        bcall _DispOP1A                 ;
updatm: ld      de,31*256+53            ; write speed
        ld      (_penCol),de             ;
        ld      a,(speed)               ;
        bcall _SetXXOP1                 ;
        bcall _DispOP1A                 ;
menul:  call getcsc                    ;
        cp      15                      ; [CLEAR]
        jp      z,quit                  ; quit
        cp      48                      ; [ALPHA]
        jr      nz,nchngs               ;
        ld      hl,speed                ; change num players
        ld      a,(hl)                  ;
        xor     %00000011               ;
        ld      (hl),a                  ;
        jr      updatm                  ;
nchngs: cp      54                      ; [2nd]
        jr      nz,menul                ;
        bcall _GRBUFCLR                 ;
        ld      hl,0                    ; reset score
        ld      (score),hl              ;
        ld      hl,ballx                ;
        ld      (hl),44                 ; ballx = 44
        inc     hl                      ;
        ld      (hl),0                  ; bally = 0
init:   call    randomblocks            ;
        ld      hl,(score)              ;
        add     hl,hl                   ; hl = score*2
        ld      a,24                    ;
        sub     h                       ;
        ld      b,a                     ;
sloop:  ld      a,b                     ;
        ld      (blockcnt),a            ;
        call    scroll                  ;
        call    checkcoll               ; check collisions
        call    putball                 ; draw ball
        push    af \ push bc \ push de \ push hl \ push ix \ push iy
        xor     a
        invoke( fastcopy )              ;
        pop     iy \ pop  ix \ pop  hl \ pop  de \ pop  bc \ pop  af
        call    putball                 ; clear ball
        ei                              ;
        ld      a,(speed)               ;
        ld      b,a                     ;
delay:  halt                            ;
        djnz    delay                   ;
        ld      a,$FF                   ;
        out     (1),a                   ;
        ld      a,$FE                   ;
        out     (1),a                   ;
        in      a,(1)                   ;
        bit     1,a                     ; [(left)]
        jr      z,moveleft              ;
        bit     2,a                     ; [(right)]
        jr      z,moveright             ; 
donemv: call    getcsc                    ;
        cp      15                      ; [CLEAR]
        jp      z,exit                  ;
        cp      55                      ; [MODE]
        jr      nz,npause               ;
        ld      a,1                     ; turn off calc
        out     (3),a                   ;
        ei                              ;
        halt                            ;
npause: ld      a,(blockcnt)            ;
        ld      b,a                     ;
        djnz    sloop                   ;
        jr      init                    ;

moveleft:
        ld      a,(ballx)               ;
        sub     2                       ;
        jr      c,donemv                ; offscreen
        ld      (tmpx),a                ;
        jr      xcheck                  ;

moveright:
        ld      a,(ballx)               ;
        add     a,2                     ;
        cp      96-4                    ;
        jr      nc,donemv               ; offscreen
        ld      (tmpx),a                ;
        add     a,5                     ; check right side
xcheck: ld      hl,bally                ;
        ld      e,(hl)                  ;
        call    ionGetPixel             ;as macrodie does not have this one i have to include it on the program
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,donemv               ; something in way
        ld      de,5*12                 ;
        add     hl,de                   ; something in way
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,donemv               ;
        ld      a,(tmpx)                ;
        ld      (ballx),a               ; move ball
        jr      donemv                  ;


randomblocks:
        ld      b,12                    ; 12 blocks
        ld      hl,_plotSScreen+(60*12)        ;
rloop1: push    bc                      ;
        push    hl                      ;
        ld      b,4                     ;
        call    ionRandom               ; as macrodie does not have this one for now i will have to include it on the source
        pop     hl                      ;
        or      a                       ;
        jr      z,rloop3                ; skip space
        ld      ix,block                ;
        ld      de,12                   ;
        ld      b,4                     ; 4 lines
        push    hl                      ;
rloop2: ld      a,(ix)                  ;
        ld      (hl),a                  ;
        inc     ix                      ;
        add     hl,de                   ;
        djnz    rloop2                  ;
        pop     hl                      ;
rloop3: inc     hl                      ;
        pop     bc                      ;
        djnz    rloop1                  ;
        ld      hl,_plotSScreen+(60*12)        ;
        ld      b,12                    ;
        xor     a                       ;
rloop4: ld      c,(hl)                  ;
        rrc     c                       ;
        adc     a,0                     ;
        djnz    rloop4                  ;
        cp      12                      ; less than 12 bricks
        ret     c                       ;
        ld      b,12                    ;
        call    ionRandom               ; put random space
        ld      hl,_plotSScreen+(60*12)        ;
        ld      d,0                     ;
        ld      e,a                     ;
        add     hl,de                   ;
        ld      b,4                     ;
        ld      de,12                   ;
rloop5: ld      (hl),0                  ;
        add     hl,de                   ;
        djnz    rloop5                  ;
        ret                             ;


scroll: ld      hl,_plotSScreen+12             ;
        ld      de,_plotSScreen                ;
        ld      bc,756                  ;
        ldir                            ;
        ld      h,d                     ;
        ld      l,e                     ;
        inc     e                       ;
        ld      (hl),b                  ;
        ld      c,11                    ;
        ldir                            ;
        ret                             ;


checkcoll:
        ld      a,(bally)               ;
        add     a,6                     ;
        ld      e,a                     ;
        ld      a,(ballx)               ;
        call    ionGetPixel             ; check left
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,ndown                ;
        ld      a,(bally)               ;
        add     a,6                     ;
        ld      e,a                     ;
        ld      a,(ballx)               ;
        add     a,5                     ;
        call    ionGetPixel             ; check right
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,ndown                ;
        ld      hl,(score)              ; inc score
        inc     hl                      ;
        ld      (score),hl              ;
        ld      hl,bally                ; move the ball down 
        inc     (hl)                    ;
        ld      a,(hl)                  ;
        cp      60-5                    ;
        ret     c                       ;
        dec     (hl)                    ;
        ret                             ;

ndown:  ld      a,(bally)               ;
        add     a,5                     ;
        ld      e,a                     ;
        ld      a,(ballx)               ;
        call    ionGetPixel             ; check left
        ld      a,(hl)                  ;
        or      a                       ;
        jr      nz,moveup               ; move up
        ld      a,(bally)               ;
        add     a,5                     ;
        ld      e,a                     ;
        ld      a,(ballx)               ;
        add     a,5                     ;
        call    ionGetPixel             ; check right
        ld      a,(hl)                  ;
        or      a                       ;
        ret     z                       ;

moveup: ld      hl,bally                ;
        dec     (hl)                    ;
        ld      a,(hl)                  ;
        and     %10000000               ; y<0
        ret     z                       ;
        pop     hl                      ;
exit:   bcall  _GRBUFCLR                ;clear only the buffer
        xor    a
        invoke( fastcopy )              ; update screen
        LD     HL,0
        LD     (_penCol),HL                  ;
        set    fracDrawLFont, (IY + fontFlags)
        ld      hl,scorestr             ;
        bcall   _VPutS                    ; write "Score: "
        ld      hl,(score)              ;
        bcall   _SetXXXXOP2
        bcall   _OP2ToOP1               ;move OP2 to OP1
        LD      A,5
        bcall   _DispOP1A               ;                ;
        ld      hl,(score)              ;
        ld      de,(high)               ;
        bcall   _CpHLDE                  ;
        jr      c,exitl                 ;
        ld      (high),hl               ;
        LD      HL,9*256+0
        LD      (_penCol),HL
        ld      hl,highstr              ;
        bcall   _VPutS                    ; write "New High!"
        res     fracDrawLFont, (IY + fontFlags)
exitl:  call   getcsc                    ;
        cp      54                      ;2nd
        jp      z,start_of_program      ;
        jr      exitl                   ;


putball:
        ld      b,6                     ;
        ld      hl,ballx                ;
        ld      a,(hl)                  ;
        inc     hl                      ;
        ld      l,(hl)                  ;
        ld      h,a
        ld      ix,ball
        push    bc
        ld      c,1                 ;
        push    af
        xor     a
        invoke( putsprite )
        pop     af
        pop     bc
        ret
getcsc:
        LD     A,$BF
        OUT    (1),A
        IN     A,(1)
        CP     $DF
        jr     z,second_key
        CP     $BF
        jr     z,mode_key
        LD     A,$DF
        OUT    (1),A
        IN     A,(1)
        CP     $7F
        jr     z,alpha_key
        LD     A,$FD
        OUT    (1),A
        IN     A,(1)
        CP     $BF
        jr     z,clear_key
        xor    a
        ret
second_key:
        ld    a,54
        ret
mode_key:
        ld    a,55
        ret
alpha_key:
        ld    a,48
        ret
clear_key:
        ld    a,15
        ret
ionGetPixel:
;---------= Get location of a pixel =---------
; input:    e=y coordinate
;       a=x coordinate
; output:   a holds data for pixel (e.g. %00100000)
;               hl->byte where pixel is on the plotsscreen
;
getpix:
 ld      d,$00
 ld      h,d
 ld      l,e
 add     hl,de
 add     hl,de
 add     hl,hl
 add     hl,hl
 ; ION wants an offset?
 ld      de,_plotSScreen
 add     hl,de
getbit:
 ld      b,$00
 ld      c,a
 and     %00000111
 srl     c
 srl     c
 srl     c
 add     hl,bc
 ld      b,a
 inc     b
 ld      a,%00000001
gblp:
 rrca
 djnz    gblp
 ret        

quit:
    LD   A,(activ_task)
    LD   (close_task),A ;send msg to macrodie for closing this activ task   
    XOR  A
    LD   (activ_task),A
    LD   (screen),A
    LD   (animar_flag),A
    RET  ;return to macrodie





ionRandom:
;---------= Random number generator =---------
; input b=upper bound
; ouput a=answer 0<=a<b
; all registers are preserved except: af and bc
;
rand:
 push    hl
 push    de
 ld      hl,(data)
 ld      a,r
 ld      d,a
 ld      e,(hl)
 add     hl,de
 add     a,l
 xor     h
 ld      (data),hl
 ld      hl,0
 ld      e,a
 ld      d,h
randl:
 add     hl,de
 djnz    randl
 ld      a,h
 pop     de
 pop     hl
 ret
background_task:;// background task as it's not needed we end it with an ret
        RET

start_of_vars:
titlestr:       .db     "Falldown",0
authorstr:      .db     "By AE, FD, and IG",0
reauthor        .db     "modified by rayden",0
startstr:       .db     "2nd - Start",0
playerstr:      .db     "ALPHA - Speed:",0
exitstr:        .db     "CLEAR - Exit",0
hscorestr:      .db     "High: ",0
scorestr:       .db     "Score:",0
highstr:        .db     "New High!",0

high:           .dw     0
speed:          .db     1

block:  .db     %11111111
        .db     %10000001
        .db     %10111111
        .db     %11111111
ball:   .db     %01111000
        .db     %10110100
        .db     %11001100
        .db     %11001100
        .db     %10110100
        .db     %01111000
saferam1 .db 0,0,0,0,0,0,0,0,0,0
ballx       .equ    saferam1        ; 1 byte  - ball x coord
bally       .equ    ballx+1         ; 1 byte  - ball y coord
blockcnt    .equ    bally+1         ; 1 byte  - num blocks
score       .equ    blockcnt+1      ; 2 bytes - score
tmpx        .equ    score+2         ; 1 byte  - temp x coord
data        .db 0,0
background_program_status        .db 0;// variable for knowing if the table as been already added
end_of_vars:
        .end
